#ifndef EFL_GENERATED_ELM_APP_CLIENT_HH
#define EFL_GENERATED_ELM_APP_CLIENT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_app_client.eo.h"
}

#include "eo_base.eo.hh"
#include <string>

struct elm_app_client;

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

struct elm_app_client
{
   void view_all_close() const;

   void terminate() const;

   /// @param args 
   /// @param view_open_cb 
   /// @param data 
   ///
   Elm_App_Client_Pending * view_open(Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_) const;

   /// @param pending 
   ///
   void view_open_cancel(Elm_App_Client_Pending * pending_) const;

   Eina_Iterator * views_get() const;

   ::efl::eina::string_view package_get() const;

   template <typename F>
   ::efl::eo::signal_connection
   callback_view_created_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_CREATED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_CREATED );
   }

   template <typename T>
   void
   callback_view_created_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_CREATED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_view_deleted_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_DELETED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_DELETED );
   }

   template <typename T>
   void
   callback_view_deleted_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_DELETED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_view_list_loaded_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED );
   }

   template <typename T>
   void
   callback_view_list_loaded_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_application_terminated_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED );
   }

   template <typename T>
   void
   callback_application_terminated_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_APP_CLIENT_CLASS);
   }

   operator ::elm_app_client() const;
   operator ::elm_app_client&();
   operator ::elm_app_client const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm_app_client*() const { return static_cast<::elm_app_client*>(static_cast<D const*>(this)->p); }
      operator ::elm_app_client const*() const { return static_cast<::elm_app_client const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm_app_client const*() const { return static_cast<::elm_app_client const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}
/// @endcond

/// @brief Class elm_app_client
struct elm_app_client
      : ::efl::eo::concrete
      , EO_CXX_INHERIT(eo::base)
{
   /// @cond LOCAL
   struct _c_constructor
   {

      explicit _c_constructor(::efl::eina::string_view package_)
         : package_(package_)
      {}
      void operator()()
      {
         ::elm_app_client_constructor(::efl::eolian::to_c(package_));
      }
      void register_ev_del_free_callback(Eo* _eoptr)
      {
         (void) _eoptr;
      }

      ::efl::eina::string_view package_;
   };
   /// @endcond

   //@{
   /**
      @brief Constructs a new elm_app_client object.

      Constructs a new elm_app_client object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Since this class have a necessary constructor method, you must call it
      in the right place within this constructor parameters.

      Example:
      @code
      elm_app_client my_elm_app_client(efl::eo::parent = parent_object,
         my_elm_app_client.constructor(package_));
      @endcode

      @see elm_app_client::constructor
      @see elm_app_client(Eo* eo)
   */
   explicit elm_app_client(::efl::eo::parent_type _p, _c_constructor _c0)
      : elm_app_client(_ctors_call(_p, _c0))
   {}

   explicit elm_app_client(_c_constructor _c0)
      : elm_app_client(_ctors_call(::efl::eo::parent = nullptr, _c0))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_app_client(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_app_client(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_app_client(elm_app_client const& other)
      : elm_app_client(eo_ref(other._eo_ptr()))
   {}

   ~elm_app_client() {}

   /// @param package 
   ///
   static _c_constructor constructor(::efl::eina::string_view package_);

   void view_all_close() const;

   void terminate() const;

   /// @param args 
   /// @param view_open_cb 
   /// @param data 
   ///
   Elm_App_Client_Pending * view_open(Eina_Value * args_, Elm_App_Client_Open_View_Cb view_open_cb_, const void * data_) const;

   /// @param pending 
   ///
   void view_open_cancel(Elm_App_Client_Pending * pending_) const;

   Eina_Iterator * views_get() const;

   ::efl::eina::string_view package_get() const;

   template <typename F>
   ::efl::eo::signal_connection
   callback_application_terminated_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED );
   }

   template <typename T>
   void
   callback_application_terminated_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_APPLICATION_TERMINATED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_add_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_ADD, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         EO_BASE_EVENT_CALLBACK_ADD );
   }

   template <typename T>
   void
   callback_callback_add_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_ADD, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         EO_BASE_EVENT_CALLBACK_DEL );
   }

   template <typename T>
   void
   callback_callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_DEL, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         EO_BASE_EVENT_DEL );
   }

   template <typename T>
   void
   callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_DEL, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_view_created_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_CREATED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_CREATED );
   }

   template <typename T>
   void
   callback_view_created_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_CREATED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_view_deleted_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_DELETED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_DELETED );
   }

   template <typename T>
   void
   callback_view_deleted_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_DELETED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_view_list_loaded_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_client, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_client, function_type>,
         ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED );
   }

   template <typename T>
   void
   callback_view_list_loaded_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_CLIENT_EVENT_VIEW_LIST_LOADED, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_APP_CLIENT_CLASS);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm_app_client::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm_app_client* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm_app_client::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm_app_client const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p, _c_constructor _c0)
   {
      Eo* _ret_eo = eo_add_ref(ELM_APP_CLIENT_CLASS, _p._eo_raw, _c0());

      _c0.register_ev_del_free_callback(_ret_eo);
      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm_app_client) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm_app_client>::value, "");


#include "elm_app_client.eo.impl.hh"

#endif // EFL_GENERATED_ELM_APP_CLIENT_HH

